# Unlinkability in ProVerif: UnlinkVerif

UnlinkVerif is a tool used to improve the accuracy of ProVerif models.
Given a ProVerif file as input, this front-end applies two transformations:
- it duplicates the `get tab() suchthat D in P else Q` commands in order to desynchronize left and right sides of the bi-process;
- it adds axioms to improve the accuracy of ProVerif when manipulating `else` branches.
Because the syntax of input files follows the syntax of ProVerif models, this tool re-uses parts of ProVerif source code (e.g., parser, ast) originally provided by B. Blanchet, V. Cheval and M. Sylvestre, that have been slightly modified for our purpose.


## How to use?
The tool can be built using the command `./build`.
It requires an up-tp-date OCaml installation.
The compilation generate the binary `unlinkverif`.

Files can then be generated using the command: `./unlinkverif ./examples/protocol.pv`.
It creates the file `output.pv` which contains the transformed model which can be analysed using ProVerif.
Note that a different name can be done to the generated file using the command:  `./unlinkverif -o newfile.pv ./examples/protocol.pv`

A small script is provided to automatically generate the tranformed models for the 4 examples mentionned in the paper.

## About OSK-v2
The two files `examples/OSK-V2.pv` and `examples/OSK-V2-manually-transformed.pv`
model the OSK-V2 protocol.
They respectively contain:
- the initial model before any transformation;
- the final model used to establish the proof of security. It embeds the two transformations
presented in the paper, plus a transformation "à la GSVerif" to improve ProVerif accuracy
regarding cells.
Details about GSVerif can be found at: https://sites.google.com/site/globalstatesverif/
