let user_message =
  let str = ref "UnlikVerif : A front end for Proverif.\n" in
  let new_line s = str := Printf.sprintf "%s\n%s" !str s in
  new_line "The input file have almost the same syntax as input files for ProVerif.";
  new_line "Some options available in ProVerif are not accepted by the front-end but";
  new_line "and an error message will be displayed in such cases.";
  !str


let out_file = ref "output.pv"
let first_file = ref true

let anal_file s =
  if not (!first_file) then
    Parsing_helper.user_error "Error: You can analyze a single ProVerif file for each run of the front end.\nPlease rerun the front end with your second file.\n";

  first_file := false;

  Printf.printf "Starting the transformation...\n";
  let decl = Transform.parse_file s in

  Printf.printf "Writing in the output file...\n";
  let channel_out = open_out !out_file in
  Printf.fprintf channel_out "%s" (Display.display_all decl);
  close_out channel_out;
  Printf.printf "Translation complete !\n"

let _ =
  Arg.parse
    [ "-o", Arg.String(fun s -> out_file := s),
        "<filename> \tchoose the output file name"
    ]
    anal_file user_message
